> For the complete documentation index, see [llms.txt](https://docs.xaman.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xaman.dev/concepts/payloads-sign-requests/delivery/push.md).

# Push

Delivering Sign Requests using a push notification can be a very convenient way for end users to interact with your application: they don't even have to scan a QR code.

{% hint style="info" %}
[xApps ("dApps")](/environments/xapps-dapps.md) and [Browser ("Web3")](/environments/browser-web3.md) are signed in with user context, so payloads created in those environments will automatically be pushed to the signed-in user.

This means if you're using the xApp / Browser (Web3) flow, you do not have to specify the **user\_token** as the payloads created from the xApp / Browser (Web3) flow are automatically pushed to the signed-in user.
{% endhint %}

If you are building a backend integration, the flow is slightly different.

## Backend

If your application features user sign-in (to identify your user) and you obtained a `user_token` from a **previously signed payload from this specific user**, you can add the `user_token` to the next payload to deliver the payload through a push notification.

The first interaction (to obtain the `user_token`) will always involve either: showing a QR code for the user to scan with the **Xumm** app or a deep link to the **Xumm** app to sign a payload.

A payload containing a user token looks like this:

```json
{
  "user_token": "c5bc4ccc-28fa-4080-b702-0d3aac97b993",
  "txjson": { ... }
}
```

After posting the payload the Xumm SDK/API, the response will confirm push notification delivery:

```json
{
  "uuid": "<some-uuid>",
  ...
  "pushed": true
}
```

{% hint style="success" %}

#### User token expiration

The issued user token expires 30 days after the **last** successfully signed payload of your application by the Xumm user using the same issued user token. If there's a good reason for your application to have longer living user tokens, please contact Xumm Support and explain your use case.
{% endhint %}

## Obtaining the \`user\_token\`

### From a webhook

After the end user resolves the sign request by signing, the configured application Webhook URL will receive a JSON body per POST request containing the `accessToken` section:

```json
{
  "meta": { ... },
  "payloadResponse": { ... },
  "userToken": {
    "user_token": "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxx",
    ...
  }
}
```

### From a resolved Payload

When you get the payload results, the `application`.`issued_user_token` contains the user token.

```json
{
  "meta": { ... },
  "application": {
    "issued_user_token": "e5fff0d0-698d-425d-bdcf-3156e744282d",
    ...
  },
  ...
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.xaman.dev/concepts/payloads-sign-requests/delivery/push.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
